diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/object-base.cc ns-3.36/src/core/model/object-base.cc
--- ns-3.35/src/core/model/object-base.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/object-base.cc	2022-04-30 18:23:57.798733200 -0700
@@ -26,6 +26,7 @@
 
 #include <cstdlib>  // getenv
 #include <cstring>  // strlen
+#include <unordered_map>
 
 /**
  * \file
@@ -39,6 +40,64 @@
 
 NS_OBJECT_ENSURE_REGISTERED (ObjectBase);
 
+  /** Unnamed namespace */
+namespace {
+
+/**
+ * Get key, value pairs from the "NS_ATTRIBUTE_DEFAULT" environment variable.
+ *
+ * \param [in] key The key to search for.
+ * \return \c true if the key was found, and the associated value.
+ */
+std::pair<bool, std::string>
+EnvDictionary (std::string key)
+{
+  static std::unordered_map<std::string, std::string> dict;
+
+  if (dict.size () == 0)
+    {
+      const char *envVar = getenv ("NS_ATTRIBUTE_DEFAULT");
+      if (envVar != 0 && std::strlen (envVar) > 0)
+        {
+          std::string env = envVar;
+          std::string::size_type cur = 0;
+          std::string::size_type next = 0;
+          while (next != std::string::npos)
+            {
+              next = env.find (";", cur);
+              std::string tmp = std::string (env, cur, next - cur);
+              std::string::size_type equal = tmp.find ("=");
+              if (equal != std::string::npos)
+                {
+                  std::string name = tmp.substr (0, equal);
+                  std::string envval = tmp.substr (equal + 1, tmp.size () - equal - 1);
+                  dict.insert ({name, envval});
+                }
+              cur = next + 1;
+            }
+        }
+      else
+        {
+          // insert an empty key, so we don't do this again
+          dict.insert ({"", ""});
+        }
+    }
+
+  std::string value;
+  bool found {false};
+
+  auto loc = dict.find (key);
+  if (loc != dict.end ())
+    {
+      value = loc->second;
+      found = true;
+    }
+  return {found, value};
+}
+
+} // unnamed namespace
+  
+
 /**
  * Ensure the TypeId for ObjectBase gets fully configured
  * to anchor the inheritance tree properly.
@@ -76,25 +135,49 @@
   NS_LOG_FUNCTION (this);
 }
 
+/**
+ * \def LOG_WHERE_VALUE(where, value)
+ * Log where and what value we find for the attribute
+ * \param where The source of the value
+ * \param value The value found, or "nothing"
+ */
+#ifdef NS3_LOG_ENABLE
+#define LOG_WHERE_VALUE(where, value)                                   \
+  do {                                                                  \
+    std::string valStr {"nothing"};                                     \
+    if (value)                                                          \
+      {                                                                 \
+        valStr = "\"" + value->SerializeToString (info.checker) + "\""; \
+      }                                                                 \
+    NS_LOG_DEBUG (where << " gave " << valStr);                         \
+  } while (false)
+#else
+#define LOG_WHERE_VALUE(where, value)
+#endif
+  
 void
 ObjectBase::ConstructSelf (const AttributeConstructionList &attributes)
 {
   // loop over the inheritance tree back to the Object base class.
   NS_LOG_FUNCTION (this << &attributes);
   TypeId tid = GetInstanceTypeId ();
-  do
+  do    // Do this tid and all parents
     {
       // loop over all attributes in object type
-      NS_LOG_DEBUG ("construct tid=" << tid.GetName () << ", params=" << tid.GetAttributeN ());
+      NS_LOG_DEBUG ("construct tid=" << tid.GetName () << 
+                    ", params=" << tid.GetAttributeN ());
       for (uint32_t i = 0; i < tid.GetAttributeN (); i++)
         {
           struct TypeId::AttributeInformation info = tid.GetAttribute (i);
           NS_LOG_DEBUG ("try to construct \"" << tid.GetName () << "::" <<
                         info.name << "\"");
-          // is this attribute stored in this AttributeConstructionList instance ?
-          Ptr<AttributeValue> value = attributes.Find (info.checker);
+
+          Ptr<const AttributeValue> value = attributes.Find (info.checker);
+          std::string where = "argument";
+
+          LOG_WHERE_VALUE (where, value);
           // See if this attribute should not be set here in the
-          // constructor.
+          // constructor. 
           if (!(info.flags & TypeId::ATTR_CONSTRUCT))
             {
               // Handle this attribute if it should not be
@@ -103,6 +186,7 @@
                 {
                   // Skip this attribute if it's not in the
                   // AttributeConstructionList.
+                  NS_LOG_DEBUG ("skipping, not settable at construction");
                   continue;
                 }
               else
@@ -114,57 +198,44 @@
                 }
             }
 
-          if (value != 0)
+          if (!value)
             {
-              // We have a matching attribute value.
-              if (DoSet (info.accessor, info.checker, *value))
+              auto [found, val] = EnvDictionary (tid.GetAttributeFullName (i));
+              if (found)
                 {
-                  NS_LOG_DEBUG ("construct \"" << tid.GetName () << "::" <<
-                                info.name << "\"");
-                  continue;
+                  value = Create<StringValue> (val);
+                  where = "env var";
+                  LOG_WHERE_VALUE (where, value);
                 }
             }
 
-          // No matching attribute value so we try to look at the env var.
-          const char *envVar = getenv ("NS_ATTRIBUTE_DEFAULT");
-          if (envVar != 0 && std::strlen (envVar) > 0)
+          bool initial = false;
+          if (!value)
             {
-              std::string env = envVar;
-              std::string::size_type cur = 0;
-              std::string::size_type next = 0;
-              while (next != std::string::npos)
-                {
-                  next = env.find (";", cur);
-                  std::string tmp = std::string (env, cur, next - cur);
-                  std::string::size_type equal = tmp.find ("=");
-                  if (equal != std::string::npos)
-                    {
-                      std::string name = tmp.substr (0, equal);
-                      std::string envval = tmp.substr (equal + 1, tmp.size () - equal - 1);
-                      if (name == tid.GetAttributeFullName (i))
-                        {
-                          if (DoSet (info.accessor, info.checker, StringValue (envval)))
-                            {
-                              NS_LOG_DEBUG ("construct \"" << tid.GetName () << "::" <<
-                                            info.name << "\" from env var");
-                              break;
-                            }
-                        }
-                    }
-                  cur = next + 1;
-                }
+              // Set from Tid initialValue, which is guaranteed to exist
+              value = info.initialValue;
+              where = "initial value";
+              initial = true;
+              LOG_WHERE_VALUE (where, value);
             }
 
-          // No matching attribute value so we try to set the default value.
-          DoSet (info.accessor, info.checker, *info.initialValue);
-          NS_LOG_DEBUG ("construct \"" << tid.GetName () << "::" <<
-                        info.name << "\" from initial value.");
-        }
+          if (DoSet (info.accessor, info.checker, *value) || initial)
+            {
+              // Setting from initial value may fail, e.g. setting
+              // ObjectVectorValue from ""
+              // That's ok, so we still report success since construction is complete
+              NS_LOG_DEBUG ("construct \"" << tid.GetName () << "::" <<
+                            info.name << "\" from " << where);
+            }
+          
+        }  // for i attributes
       tid = tid.GetParent ();
     }
   while (tid != ObjectBase::GetTypeId ());
   NotifyConstructionCompleted ();
+
 }
+#undef LOG_WHERE_VALUE
 
 bool
 ObjectBase::DoSet (Ptr<const AttributeAccessor> accessor,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/pair.h ns-3.36/src/core/model/pair.h
--- ns-3.35/src/core/model/pair.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/pair.h	2022-04-30 18:23:57.798733200 -0700
@@ -31,6 +31,14 @@
 
 namespace ns3 {
 
+/**
+ * Output streamer for a std::pair.
+ * \tparam A \deduced Type of the `pair.first`.
+ * \tparam B \deduced Type of the `pair.second`.
+ * \param [in,out] os The output stream.
+ * \param [in] p The pair.
+ * \returns The output stream.
+ */
 template <class A, class B>
 std::ostream &
 operator << (std::ostream &os, const std::pair<A, B> &p)
@@ -50,9 +58,9 @@
   /** Type of value stored in the PairValue. */
   typedef std::pair<Ptr<A>, Ptr<B> > value_type;
   /** Type of abscissa (first entry of pair). */
-  typedef typename std::result_of<decltype(&A::Get)(A)>::type first_type;
+  typedef typename std::invoke_result_t<decltype(&A::Get), A> first_type;
   /** Type of ordinal (second entry of pair). */
-  typedef typename std::result_of<decltype(&B::Get)(B)>::type second_type;
+  typedef typename std::invoke_result_t<decltype(&B::Get), B> second_type;
   /** Type returned by Get or passed in Set. */
   typedef typename std::pair<first_type, second_type> result_type;
 
@@ -78,10 +86,7 @@
    * \return stored value as std::pair<A, B>.
    */
   result_type Get (void) const;
-  /**
-   * Set the stored value.
-   * \param[in] value std::pair<A, B> to be stored.
-   */
+  /* Documented by print-introspected-doxygen.cc */
   void Set (const result_type &value);
 
   template <typename T>
@@ -94,6 +99,7 @@
 class PairChecker : public AttributeChecker
 {
 public:
+  /** Type holding an AttributeChecker for each member of a pair. */
   typedef std::pair<Ptr<const AttributeChecker>, Ptr<const AttributeChecker> > checker_pair_type;
 
   /**
@@ -170,13 +176,21 @@
 class PairChecker : public ns3::PairChecker
 {
 public:
+  /** Default c'tor. */
   PairChecker (void);
+  /**
+   * Construct from a pair of AttributeChecker's.
+   * \param firstchecker The AttributeChecker for first.
+   * \param secondchecker The AttributeChecker for second.
+   */
   PairChecker (Ptr<const AttributeChecker> firstchecker, Ptr<const AttributeChecker> secondchecker);
   void SetCheckers (Ptr<const AttributeChecker> firstchecker, Ptr<const AttributeChecker> secondchecker);
   typename ns3::PairChecker::checker_pair_type GetCheckers (void) const;
 
 private:
+  /** The first checker. */
   Ptr<const AttributeChecker> m_firstchecker;
+  /** The second checker. */
   Ptr<const AttributeChecker> m_secondchecker;
 };
 
@@ -334,6 +348,14 @@
   return true;
 }
 
+/**
+ * Create an AttributeAccessor for std::pair<>.
+ * \tparam A \explicit The type of pair.first.
+ * \tparam B \explicit The type of pair.second.
+ * \tparam T1 \deduced The argument pair type.
+ * \param [in] a1 The std::pair to be accessed.
+ * \returns The AttributeAccessor.
+ */
 template <typename A, typename B, typename T1>
 Ptr<const AttributeAccessor> MakePairAccessor (T1 a1)
 {
@@ -342,4 +364,4 @@
 
 } // namespace ns3
 
-#endif // PAIR_H
\ No newline at end of file
+#endif // PAIR_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/random-variable-stream.cc ns-3.36/src/core/model/random-variable-stream.cc
--- ns-3.35/src/core/model/random-variable-stream.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/random-variable-stream.cc	2022-04-30 18:23:57.798733200 -0700
@@ -33,7 +33,6 @@
 #include "log.h"
 #include "rng-stream.h"
 #include "rng-seed-manager.h"
-#include "unused.h"
 #include <cmath>
 #include <iostream>
 #include <algorithm>    // upper_bound
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/realtime-simulator-impl.cc ns-3.36/src/core/model/realtime-simulator-impl.cc
--- ns-3.35/src/core/model/realtime-simulator-impl.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/realtime-simulator-impl.cc	2022-04-30 18:23:57.798733200 -0700
@@ -80,13 +80,8 @@
 
   m_stop = false;
   m_running = false;
-  // uids are allocated from 4.
-  // uid 0 is "invalid" events
-  // uid 1 is "now" events
-  // uid 2 is "destroy" events
-  m_uid = 4;
-  // before ::Run is entered, the m_currentUid will be zero
-  m_currentUid = 0;
+  m_uid = EventId::UID::VALID;
+  m_currentUid = EventId::UID::INVALID;
   m_currentTs = 0;
   m_currentContext = Simulator::NO_CONTEXT;
   m_unscheduledEvents = 0;
@@ -330,6 +325,10 @@
     NS_ASSERT_MSG (m_events->IsEmpty () == false,
                    "RealtimeSimulatorImpl::ProcessOneEvent(): event queue is empty");
     next = m_events->RemoveNext ();
+
+    PreEventHook (EventId (next.impl, next.key.m_ts, 
+                           next.key.m_context, next.key.m_uid));
+
     m_unscheduledEvents--;
     m_eventCount++;
 
@@ -579,21 +578,7 @@
 RealtimeSimulatorImpl::ScheduleNow (EventImpl *impl)
 {
   NS_LOG_FUNCTION (this << impl);
-  Scheduler::Event ev;
-  {
-    CriticalSection cs (m_mutex);
-
-    ev.impl = impl;
-    ev.key.m_ts = m_currentTs;
-    ev.key.m_context = GetContext ();
-    ev.key.m_uid = m_uid;
-    m_uid++;
-    m_unscheduledEvents++;
-    m_events->Insert (ev);
-    m_synchronizer->Signal ();
-  }
-
-  return EventId (impl, ev.key.m_ts, ev.key.m_context, ev.key.m_uid);
+  return Schedule (Time (0), impl);
 }
 
 Time
@@ -683,10 +668,11 @@
 
     //
     // Time doesn't really matter here (especially in realtime mode).  It is
-    // overridden by the uid of 2 which identifies this as an event to be
+    // overridden by the uid of DESTROY which identifies this as an event to be
     // executed at Simulator::Destroy time.
     //
-    id = EventId (Ptr<EventImpl> (impl, false), m_currentTs, 0xffffffff, 2);
+    id = EventId (Ptr<EventImpl> (impl, false), m_currentTs, 0xffffffff, 
+                  EventId::UID::DESTROY);
     m_destroyEvents.push_back (id);
     m_uid++;
   }
@@ -712,7 +698,7 @@
 void
 RealtimeSimulatorImpl::Remove (const EventId &id)
 {
-  if (id.GetUid () == 2)
+  if (id.GetUid () == EventId::UID::DESTROY)
     {
       // destroy events.
       for (DestroyEvents::iterator i = m_destroyEvents.begin ();
@@ -760,7 +746,7 @@
 bool
 RealtimeSimulatorImpl::IsExpired (const EventId &id) const
 {
-  if (id.GetUid () == 2)
+  if (id.GetUid () == EventId::UID::DESTROY)
     {
       if (id.PeekEventImpl () == 0
           || id.PeekEventImpl ()->IsCancelled ())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/realtime-simulator-impl.h ns-3.36/src/core/model/realtime-simulator-impl.h
--- ns-3.35/src/core/model/realtime-simulator-impl.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/realtime-simulator-impl.h	2022-04-30 18:23:57.798733200 -0700
@@ -112,16 +112,25 @@
 
   /** \copydoc ScheduleWithContext(uint32_t,const Time&,EventImpl*) */
   void ScheduleRealtimeWithContext (uint32_t context, const Time &delay, EventImpl *event);
-  /** \copydoc Schedule(const Time&,EventImpl*) */
+  /**
+   * Schedule a future event execution (in the same context).
+   *
+   * @param [in] delay Delay until the event expires.
+   * @param [in] event The event to schedule.
+   */
   void ScheduleRealtime (const Time &delay, EventImpl *event);
   /**
-   * \copybrief ScheduleNow(EventImpl*)
+   * Schedule an event to run at the current virtual time.
    *
    * \param [in] context Event context.
    * \param [in] event The event to schedule.
    */
   void ScheduleRealtimeNowWithContext (uint32_t context, EventImpl *event);
-  /** \copydoc ScheduleNow(EventImpl*) */
+  /**
+   * Schedule an event to run at the current virtual time.
+   *
+   * @param [in] event The event to schedule.
+   */
   void ScheduleRealtimeNow (EventImpl *event);
   /**
    * Get the current real time from the synchronizer.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/show-progress.h ns-3.36/src/core/model/show-progress.h
--- ns-3.35/src/core/model/show-progress.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/show-progress.h	2022-04-30 18:23:57.798733200 -0700
@@ -165,6 +165,11 @@
   /**
    * Show execution progress.
    * This function actually generates output, when directed by CheckProgress().
+   * \param [in] nEvents The actual number of events processed since the last 
+   *             progress output.
+   * \param [in] ratio The current ratio of elapsed wall clock time to the
+   *             target update interval.
+   * \param [in] speed The execution speed relative to wall clock time.
    */
   void GiveFeedback (uint64_t nEvents, int64x64_t ratio, int64x64_t speed);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/simple-ref-count.h ns-3.36/src/core/model/simple-ref-count.h
--- ns-3.35/src/core/model/simple-ref-count.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/simple-ref-count.h	2022-04-30 18:23:57.798733200 -0700
@@ -25,7 +25,6 @@
 #include "empty.h"
 #include "default-deleter.h"
 #include "assert.h"
-#include "unused.h"
 #include <stdint.h>
 #include <limits>
 
@@ -81,19 +80,17 @@
    * Copy constructor
    * \param [in] o The object to copy into this one.
    */
-  SimpleRefCount (const SimpleRefCount &o)
+  SimpleRefCount (const SimpleRefCount & o [[maybe_unused]])
     : m_count (1)
   {
-    NS_UNUSED (o);
   }
   /**
    * Assignment operator
    * \param [in] o The object to copy
    * \returns The copy of \pname{o}
    */
-  SimpleRefCount &operator = (const SimpleRefCount &o)
+  SimpleRefCount &operator = ([[maybe_unused]] const SimpleRefCount &o)
   {
-    NS_UNUSED (o);
     return *this;
   }
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/simulation-singleton.h ns-3.36/src/core/model/simulation-singleton.h
--- ns-3.35/src/core/model/simulation-singleton.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/simulation-singleton.h	2022-04-30 18:23:57.798733200 -0700
@@ -43,6 +43,11 @@
 class SimulationSingleton
 {
 public:
+  // Delete default constructor, copy constructor and assignment operator to avoid misuse
+  SimulationSingleton<T> () = delete;
+  SimulationSingleton<T> (const SimulationSingleton<T> &) = delete;
+  SimulationSingleton<T> & operator = (const SimulationSingleton<T> &) = delete;
+
   /**
    * Get a pointer to the singleton instance.
    *
@@ -68,27 +73,6 @@
 
   /** Delete the static instance. */
   static void DeleteObject (void);
-
-  /**
-   * \name %Singleton pattern
-   * Private constructor, copy and assignment operator.
-   *
-   *  Note these do not have to be implemented, since they are
-   *  never called.
-   */
-  /**@{*/
-  /** Default constructor */
-  SimulationSingleton<T> (void);
-
-  /** Copy constructor. */
-  SimulationSingleton<T> (const SimulationSingleton<T> &);
-  /**
-   * Assignment.
-   * \returns The Singleton.
-   */
-  SimulationSingleton<T> operator = (const SimulationSingleton<T> &);
-  /**@}*/
-
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/simulator.cc ns-3.36/src/core/model/simulator.cc
--- ns-3.35/src/core/model/simulator.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/simulator.cc	2022-04-30 18:23:57.798733200 -0700
@@ -286,7 +286,7 @@
 
 Time Now (void)
 {
-  return Time (Simulator::Now ());
+  return Simulator::Now ();
 }
 
 Time
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/simulator.h ns-3.36/src/core/model/simulator.h
--- ns-3.35/src/core/model/simulator.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/simulator.h	2022-04-30 18:23:57.798733200 -0700
@@ -464,7 +464,6 @@
    * @param [in] delay Delay until the event expires.
    * @param [in] context Event context.
    * @param [in] event The event to schedule.
-   * @returns A unique identifier for the newly-scheduled event.
    */
   static void ScheduleWithContext (uint32_t context, const Time &delay, EventImpl *event);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/simulator-impl.h ns-3.36/src/core/model/simulator-impl.h
--- ns-3.35/src/core/model/simulator-impl.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/simulator-impl.h	2022-04-30 18:23:57.798733200 -0700
@@ -102,6 +102,13 @@
   /** \copydoc Simulator::GetEventCount */
   virtual uint64_t GetEventCount (void) const = 0;
 
+  /** 
+   * Hook called before processing each event.
+   *
+   * \param [in] id The event about to be processed.
+   */
+  virtual void PreEventHook (const EventId & id) {};
+
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/singleton.h ns-3.36/src/core/model/singleton.h
--- ns-3.35/src/core/model/singleton.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/singleton.h	2022-04-30 18:23:57.798733200 -0700
@@ -20,9 +20,6 @@
 #ifndef SINGLETON_H
 #define SINGLETON_H
 
-#include "non-copyable.h"
-
-
 /**
  * \file
  * \ingroup access
@@ -60,9 +57,13 @@
  * finalizer.
  */
 template <typename T>
-class Singleton : private NonCopyable
+class Singleton
 {
 public:
+  // Delete copy constructor and assignment operator to avoid misuse
+  Singleton<T> (const Singleton<T> &) = delete;
+  Singleton<T> & operator = (const Singleton<T> &) = delete;
+
   /**
    * Get a pointer to the singleton instance.
    *
@@ -73,6 +74,16 @@
    */
   static T * Get (void);
 
+protected:
+  /** Constructor. */
+  Singleton<T> ()
+  {
+  }
+
+  /** Destructor. */
+  virtual ~Singleton<T> ()
+  {
+  }
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/synchronizer.h ns-3.36/src/core/model/synchronizer.h
--- ns-3.35/src/core/model/synchronizer.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/synchronizer.h	2022-04-30 18:23:57.798733200 -0700
@@ -165,9 +165,11 @@
    * waiting in the Synchronize method that an event has happened which demands
    * a reevaluation of the wait time.
    *
+   * @param [in] cond The new value for the condition variable.
+   *
    * @see Signal
    */
-  void SetCondition (bool);
+  void SetCondition (bool cond);
 
   /**
    * @brief Ask the synchronizer to remember what time it is.
@@ -282,9 +284,10 @@
    * waiting in the Synchronize method that an event has happened which
    * demands a reevaluation of the wait time.
    *
+   * @param [in] cond The new value for the condition variable.
    * @see SetCondition
    */
-  virtual void DoSetCondition (bool) = 0;
+  virtual void DoSetCondition (bool cond) = 0;
 
   /**
    * @brief Get the drift between the real time clock used to synchronize
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/system-condition.h ns-3.36/src/core/model/system-condition.h
--- ns-3.35/src/core/model/system-condition.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/system-condition.h	2022-04-30 18:23:57.798733200 -0700
@@ -67,6 +67,8 @@
  * context and put the processor to sleep until an event happens somewhere
  * else that
  */
+// The last two paragraphs are truncated in the earliest commit of this code:
+// 2008-07-15	Craig Dowell	add system threads and synchronization primitives
 class SystemCondition
 {
 public:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/system-thread.h ns-3.36/src/core/model/system-thread.h
--- ns-3.35/src/core/model/system-thread.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/system-thread.h	2022-04-30 18:23:57.798733200 -0700
@@ -163,6 +163,7 @@
    *
    * @param [in] arg This SystemThread instance to communicate to the newly
    *                 launched thread.
+   * @return a null pointer (for compatibility)
    */
   static void * DoRun (void *arg);
 
@@ -174,5 +175,3 @@
 } // namespace ns3
 
 #endif /* SYSTEM_THREAD_H */
-
-
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/test.cc ns-3.36/src/core/model/test.cc
--- ns-3.35/src/core/model/test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/test.cc	2022-04-30 18:23:57.798733200 -0700
@@ -325,7 +325,7 @@
       /*
         To count the bad test names, use NS_LOG_UNCOND instead
         of NS_FATAL_ERROR, and the command
-        $ ./waf --run "test-runner --list" 2>&1 | grep "^Invalid" | wc
+        $ ./ns3 run "test-runner --list" 2>&1 | grep "^Invalid" | wc
       */
       NS_LOG_UNCOND ("Invalid test name: cannot contain any of '"
                      << badchars << "': " << testCase->m_name);
